//SI5351_vfo + LCD PLL fixed at 900 MHz

#include <Adafruit_Sensor.h>
#include <Wire.h>
#include <Adafruit_SI5351.h>
#include <LiquidCrystal.h>
Adafruit_SI5351 clockgen = Adafruit_SI5351();

LiquidCrystal lcd(2,3,4,5,6,7);  

unsigned long freq;
unsigned long freqHz;

int pot;
long fstep;
long fstepOld;

void setup(void) 

{

  Serial.begin(9600);
  Serial.println("Si5351 Clockgen"); Serial.println("");

  
  /* Initialise the sensor */
  if (clockgen.begin() != ERROR_NONE)
  {
    Serial.print("Error");
    while(1);
  }
  Serial.println("OK");
  clockgen.enableOutputs(true);
  clockgen.setupPLL(SI5351_PLL_A, 36, 0, 1000);  //900 MHz
  freq=7000;
  freqHz=freq*1000;
  setfreq (freqHz);
  lcd.begin(16, 2);

  // Print a message to the LCD.
  lcd.print(freq);
  pinMode(A0, INPUT_PULLUP); 
  pinMode(A1, INPUT_PULLUP); 
}

void setfreq (unsigned long freqHz)
{
  unsigned long f2;
  unsigned long f3;
  unsigned long f4;
  unsigned long f5;
  unsigned long div2;
//  unsigned int Teiler2;
  unsigned int rdiv;
 
   if (freqHz > 0)    {  
    f2=freqHz*4;
    if (f2<1000000) {
      rdiv = 16;
      f2 = f2 * 16;
      }
    else  {
      rdiv = 1;
      }  
    div2 = 9000970000000/f2;
    f4 = div2/10000;
    f5=div2-(f4*10000);
    clockgen.setupMultisynth(1, SI5351_PLL_A, f4, f5, 10000);
    if (rdiv == 16) {
      clockgen.setupRdiv(1, SI5351_R_DIV_16);
      }
    if (rdiv == 1) {
      clockgen.setupRdiv(1, SI5351_R_DIV_1);
      } 
   }   
}

void loop(void) 
{     
   pot = analogRead(A3);
   fstep =1000000; 
   if (pot > 100) fstep =1000000; 
   if (pot > 200) fstep =500000; 
   if (pot > 300) fstep =100000; 
   if (pot > 400) fstep =20000; 
   if (pot > 500) fstep =5000; 
   if (pot > 600) fstep =1000; 
   if (pot > 700) fstep =200; 
   if (pot > 800) fstep =100; 
   if (pot > 900) fstep =20; 

   if (fstep != fstepOld){
   lcd.setCursor(1, 1);
    lcd.print(fstep);
    lcd.print ("   ");
   }
   fstepOld = fstep;
  
  if (Serial.available()) {
   freq = Serial.parseInt();
   if (freq > 0){
    lcd.setCursor(0, 0);
    freqHz=freq*1000-12000;
    lcd.print(freq);
    lcd.print ("   ");
    setfreq (freqHz);
    }
   }
  if (digitalRead(A0)==0){
   freqHz = freqHz - fstep;
   lcd.setCursor(0, 0);
   //freq=freqHz/1000;
   lcd.print(freqHz);
   setfreq (freqHz);
   lcd.print ("   ");
   delay (200);
   }
  if (digitalRead(A1)==0){
   freqHz = freqHz + fstep;
   lcd.setCursor(0, 0);
   //freq=freqHz/1000;
   lcd.print(freqHz);
   setfreq (freqHz);
   lcd.print ("   ");
   delay (200);
   }
}


